#include "ti83plusklein.inc"
#define B_CALL(xxxx) rst 28h \ .dw xxxx
#define B_JUMP(xxxx) call 50h \ .dw xxxx

Version        =1
SubVersion     =2

     .org 9D95h
     RST  18h
     res  doneprgm,(IY+doneflags)
     res  indicrun,(IY+indicflags)
Start:
     B_CALL(_clrscrnfull)
     B_CALL(_homeup)
     ld   hl,TXT_MainMenu
     set  textinverse,(IY+textflags)
     B_CALL(_puts)
     res  textinverse,(IY+textflags)
     B_CALL(_puts)
     ld   b,1
CLL_MAINMENU_Cursor:
     set  textinverse,(IY+textflags)
     XOR  a
     ld   (curcol),a
     ld   a,b
     ld   (currow),a
     ADD  a,$30
     B_CALL(_putc)
     ld   a,$3A
     B_CALL(_putc)
     res  textinverse,(IY+textflags)
CLL_MAINMENU_GetKey:
     res  oninterrupt,(IY+onflags)
     B_CALL(_getkeyretoff)
     cp   kup
     jr   z,CLL_MAINMENU_Move
     cp   kdown
     jr   z,CLL_MAINMENU_Move
     cp   kenter
     jr   z,CLL_MAINMENU_Enter
     SUB  k1
     jr   c,CLL_MAINMENU_GetKey
     cp   4
     jr   nc,CLL_MAINMENU_GetKey
     INC  a
     jr   CLL_MAINMENU_Enter2
CLL_MAINMENU_Move:
     ld   c,a
     XOR  a
     ld   (curcol),a
     ld   a,b
     ld   (currow),a
     ADD  a,$30
     B_CALL(_putc)
     ld   a,$3A
     B_CALL(_putc)
     ld   a,c
     ADD  a,a
     ADD  a,b
     SUB  7
     jr   nz,CLL_MAINMENU_Hoog
     ld   a,4
CLL_MAINMENU_Hoog:
     cp   5
     jr   nz,CLL_MAINMENU_Laag
     ld   a,1
CLL_MAINMENU_Laag:
     ld   b,a
     jr   CLL_MAINMENU_Cursor
CLL_MAINMENU_Enter:
     ld   a,b
CLL_MAINMENU_Enter2
     cp   2
     jp   c,CLL_LOCKROUT
     jp   z,CLL_ENTERPAS
     cp   4
     jr   c,CLL_DISPINFO
Quit:
     B_CALL(_poprealo1)
     B_CALL(_clrscrnfull)
     B_CALL(_homeup)
     res  ret_off,(IY+ret_off_flags)
     res  oninterrupt,(IY+onflags)
     RET
     
#include "DISPINFO.asm"
#include "DISPSPRT.asm"
#include "ENTERPAS.asm"
#include "LOCKDISP.asm"
#include "LOCKROUT.asm"
     
DAT_Invoer:
     .db  0,0,0,0,0,0,0,0
     
DAT_Invoer2:
     .db  0,0,0,0,0,0,0,0
     
DAT_Wachtwoord:
     .db  k0,k0,k0,k0,0,0,0,0
     
SPR_Bolletje:
     .db %00011100
     .db %00111010
     .db %00111110
     .db %00111110
     .db %00011100
     
TXT_Clear:
     .db  "        ",0
     
TXT_ENTERPAS:
     .db  "Enter New       "
     .db  "Password",0
     
     .db  " Again",0
     
TXT_Info:
     .db  "CALCLOCK v",Version+$30,".",SubVersion+$30,"   "
     .db  "by Guido Senden "
     .db  "Any questions?  "
     .db  "Guifes_Guevenin",$40
     .db  "mailpanda.com",0
     
TXT_Info2:
     .db  "Clear:          "
     .db  " Clear Input    "
     .db  "Del:            "
     .db  " Clear Last Char"
     .db  "Enter:          "
     .db  " Confirm Input  "
     .db  "(Off:)          "
     .db  " Return To Menu",0
     
TXT_LOCKDISP1:
     .db  "Password:",0
     
TXT_LOCKDISP2:
     .db  "CALCLOCK",$06,"v",Version+$30,".",SubVersion+$30,0
     
TXT_MainMenu:
     .db  "CALCLOCK v",Version+$30,".",SubVersion+$30,0,"   "
     .db  "1: Lock Calc    "
     .db  "2: Change Code  "
     .db  "3: Info         "
     .db  "4: Quit",0
     
     .end
END
