#define B_CALL(xxxx) rst 28h \ .dw xxxx
#define B_JUMP(xxxx) call 50h \ .dw xxxx

CLL_ENTERPAS:
     B_CALL(_clrscrnfull)
     B_CALL(_homeup)
     res  0,(IY+asm_flag1)
     ld   hl,TXT_ENTERPAS
CLL_ENTERPAS_Start:
     B_CALL(_puts)
     ld   a,$3A
     B_CALL(_putc)
     B_CALL(_newline)
     ld   bc,0
CLL_ENTERPAS_Getkey:
     res  oninterrupt,(IY+onflags)
     B_CALL(_getkey)
     cp   koff
     jr   z,CLL_ENTERPAS_Mode
     cp   kenter
     jr   z,CLL_ENTERPAS_Enter
     cp   kclear
     jr   z,CLL_ENTERPAS_Clear
     cp   kdel
     jr   z,CLL_ENTERPAS_Del
     ld   d,a
     ld   a,c
     cp   8
     jr   z,CLL_ENTERPAS_Getkey
     ld   hl,DAT_Invoer
     bit  0,(IY+asm_flag1)
     jr   z,CLL_ENTERPAS_Getkey_Run1
     ld   hl,DAT_Invoer2
CLL_ENTERPAS_Getkey_Run1:
     ADD  hl,bc
     ld   (hl),d
     INC  c
     ld   a,$2A
     B_CALL(_putc)
     jr   CLL_ENTERPAS_Getkey
CLL_ENTERPAS_Mode:
     ld   hl,DAT_Invoer
     call CLL_ENTERPAS_Clear_Input
     call CLL_ENTERPAS_Clear_Input
     jp   Start
CLL_ENTERPAS_Enter:
     bit  0,(IY+asm_flag1)
     jr   nz,CLL_ENTERPAS_Check
     set  0,(IY+asm_flag1)
     B_CALL(_newline)
     ld   hl,TXT_ENTERPAS
     B_CALL(_puts)
     jr   CLL_ENTERPAS_Start
CLL_ENTERPAS_Clear:
     ld   hl,DAT_Invoer
     bit  0,(IY+asm_flag1)
     jr   z,CLL_ENTERPAS_Clear_Run1
     ld   hl,DAT_Invoer2
CLL_ENTERPAS_Clear_Run1:
     call CLL_ENTERPAS_Clear_Input
     ld   c,a
     ld   (curcol),a
     ld   hl,TXT_Clear
     B_CALL(_puts)
     ld   (curcol),a
     jr   CLL_ENTERPAS_Getkey
CLL_ENTERPAS_Del:
     ld   a,c
     OR   a
     jr   z,CLL_ENTERPAS_Getkey
     DEC  c
     ld   hl,DAT_Invoer
     bit  0,(IY+asm_flag1)
     jr   z,CLL_ENTERPAS_Del_Run1
     ld   hl,DAT_Invoer2
CLL_ENTERPAS_Del_Run1:
     ADD  hl,bc
     XOR  a
     ld   (hl),a
     ld   a,c
     ld   (curcol),a
     ld   a,$20
     B_CALL(_putmap)
     jp   CLL_ENTERPAS_Getkey
CLL_ENTERPAS_Check:
     ld   b,8
     ld   de,DAT_Invoer2
     ld   hl,DAT_Invoer
CLL_ENTERPAS_CheckLoop:
     ld   a,(de)
     cp   (hl)
     jr   nz,CLL_ENTERPAS_CheckFail
     INC  hl
     INC  de
     DJNZ CLL_ENTERPAS_CheckLoop
     ld   de,DAT_Wachtwoord
     ld   bc,8
     LDIR
     B_CALL(_poprealo1)
     RST  18h
     B_CALL(_chkfindsym)
     ld   hl,DAT_Wachtwoord-$9D95+4
     ADD  hl,de
     ld   de,DAT_Invoer
     EX   de,hl
     ld   bc,8
     LDIR
     jp   CLL_ENTERPAS_Mode
CLL_ENTERPAS_CheckFail:
     ld   hl,DAT_Invoer
     call CLL_ENTERPAS_Clear_Input
     call CLL_ENTERPAS_Clear_Input
     jp   CLL_ENTERPAS
     
CLL_ENTERPAS_Clear_Input:
     XOR  a
     ld   b,8
CLL_ENTERPAS_Clear_Input_Loop:
     ld   (hl),a
     INC  hl
     DJNZ CLL_ENTERPAS_Clear_Input_Loop
     RET
     
     
     .end
END
