#define B_CALL(xxxx) rst 28h \ .dw xxxx
#define B_JUMP(xxxx) call 50h \ .dw xxxx

CLL_LOCKROUT:
     call CLL_LOCKDISP
     ld   bc,0
CLL_LOCKROUT_GetKey:
     res  oninterrupt,(IY+onflags)
     B_CALL(_getkey)
     cp   kclear
     jr   z,CLL_LOCKROUT_Clear
     cp   kdel
     jr   z,CLL_LOCKROUT_Del
     cp   kenter
     jr   z,CLL_LOCKROUT_Enter
     cp   koff
     jr   z,CLL_LOCKROUT_OFF
     ld   d,a
     ld   a,c
     cp   8
     jr   z,CLL_LOCKROUT_GetKey
     ld   hl,DAT_Invoer
     ADD  hl,bc
     ld   (hl),d
     call CLL_DISPSPRT
     INC  c
     jr   CLL_LOCKROUT_GetKey
CLL_LOCKROUT_Clear:
     call CLL_LOCKDISP
     XOR  a
     ld   b,8
     ld   hl,DAT_Invoer
CLL_LOCKROUT_ClearLoop:
     ld   (hl),a
     INC  hl
     DJNZ CLL_LOCKROUT_ClearLoop
     ld   c,0
     jr   CLL_LOCKROUT_GetKey
CLL_LOCKROUT_Del:
     ld   a,c
     OR   a
     jr   z,CLL_LOCKROUT_GetKey
     DEC  c
     call CLL_CLERSPRT
     XOR  a
     ld   hl,DAT_Invoer
     ADD  hl,bc
     ld   (hl),a
     jr   CLL_LOCKROUT_GetKey
CLL_LOCKROUT_Enter:
     ld   b,8
     ld   de,DAT_Invoer
     ld   hl,DAT_Wachtwoord
CLL_LOCKROUT_ChkLoop:
     ld   a,(de)
     cp   (hl)
     jr   nz,CLL_LOCKROUT_Clear
     INC  de
     INC  hl
     DJNZ CLL_LOCKROUT_ChkLoop
     jp   Quit
CLL_LOCKROUT_OFF:
     ld   a,$02
     OUT  ($10),a
CLL_LOCKROUT_Sleep:
     HALT
     bit  oninterrupt,(IY+onflags)
     jr   z,CLL_LOCKROUT_Sleep
     ld   a,$03
     OUT  ($10),a
     jr   CLL_LOCKROUT_GetKey
     
     .end
END
